-- alu.vhd 1.3 by your names here
LIBRARY IEEE;
USE work.all;
USE IEEE.Std_Logic_1164.all; 
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL; 
ENTITY alu IS
    GENERIC(SIZE : integer RANGE 2 TO 32      := 32);    -- Number of bits in ALU
    PORT(a, b    : IN      std_logic_vector(SIZE - 1 DOWNTO 0);  -- The a and b inputs
        aneg     : IN      std_logic;                    -- If '1' invert a 
        bneg     : IN      std_logic;                    -- If '1' invert b take 2's comp of b if subtract
        op       : IN      std_logic_vector(1 DOWNTO 0);         -- operation i.e. and, or, etc.
        Result   : OUT     std_logic_vector(SIZE - 1 DOWNTO 0);  -- Result of operation
        Zero     : OUT     std_logic;                    -- Set if overflow on add or sub
        overflow : OUT     std_logic;                    -- Set if Result = 0
        p        : OUT     std_logic_vector(SIZE - 1 DOWNTO 0);  -- Propagate carry 
        q        : OUT     std_logic_vector(SIZE - 1 DOWNTO 0)   -- Generate carry
        );
END alu; 
ARCHITECTURE struc OF alu IS
-- Complete the architecture.
-- The architecture must be structural using alu1 and alus as components.
-- Use the VHDL GENERATE statement (see the Designers guide to VHDL) to set up the structural so that
-- the number of bits in the ALU is determined by the GENERIC SIZE. The test bench is uses a 4 bit ALU, 
-- but your ALU must work for any size ALU form 2 to 32 bits.


END struc;
            
            
            
            
