-- alu1.vhd Version 1.1 by Dr. Jerry H. Tucker
-- Created  9/15/08 Worked     
-- Uses     NONE
LIBRARY IEEE;
USE work.all;
USE IEEE.Std_Logic_1164.all; 
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL; 
-----------------------------------------------------------------------
-- ENTITY:  ALU1 - One bit ALU as specified in class.
-----------------------------------------------------------------------
entity alu1 is
  port(a, b: in  std_logic;
        Ainvert: in  std_logic; 
        Binvert: in  std_logic;
        less: in std_logic;
--        op:   in  unsigned(1 downto 0);
        op: in std_logic_vector(1 downto 0);
        cin:  In std_logic;
        Result: out std_logic;
        cout: out std_logic;
        p: out std_logic;
        g: out std_logic);
end entity alu1; 

architecture arch of ALU1 is
    signal a_i: std_logic;
    signal b_i: std_logic;
begin
    Cout <= (a_i and b_i) or (a_i and Cin) or (b_i and Cin) after 2 ns; 
    a_i <= a after 2 ns when Ainvert = '0' else not a after 3 ns;
    b_i <= b after 2 ns when Binvert = '0' else not b after 3 ns;
    g <= a_i and b_i after 1 ns;
    p <= a_i or b_i after 1 ns;
    process(op, a_i, b_i,cin, less)
    begin
        case op is
            when "00" => -- and
                Result <= a_i and b_i after 3 ns;
            when "01" => -- or
                Result <= a_i or b_i after 3 ns;
            when "10" => -- add
                Result <= a_i xor b_i xor cin after 4 ns;
            when "11"=>  -- less
                Result <= less after 2 ns;
            When others =>
                null;
        end case;        
    end process;
end;

