-- tb_alu.vhd Version 1.0 by Dr. Jerry H. Tucker
-- Created  9/22/08     
LIBRARY IEEE;
USE work.all;
USE IEEE.Std_Logic_1164.all; 
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL; 
----------------------------------------------------------
--  ENTITY: TB - Test bench for alu.VHD
--  Uses seperate four bit ALU's running in parallel to
--  test and, or, add, sub, and less functions.
--   NEEDS: alu.vhd
----------------------------------------------------------
ENTITY TB IS
END ENTITY TB;

ARCHITECTURE TEST OF TB IS
    SIGNAL a, b: std_logic_vector(3 downto 0) := "0000";
    SIGNAL op: std_logic_vector(1 downto 0) := "00";
    SIGNAL ov_and, ov_or, ov_add, ov_sub, ov_less, Z_and, z_or, z_add, z_sub, z_less: std_logic := '0';
    SIGNAL R_and, R_or, R_add, R_sub, R_less: std_logic_vector(3 downto 0) := "0000";
BEGIN
   a <= a + 1 after 100 ns;
   b <= (not b(0)) & b(3 downto 1) after 50 ns; 

ALUand: entity work.ALU(struc) generic map(4)
         PORT MAP (a, b, '0', '0',"00", r_and, Z_and, ov_and);
ALUor: entity work.ALU(struc) generic map(4)
         PORT MAP (a,b, '0', '0',"01", r_or, Z_or, ov_or);
ALUadd: entity work.ALU(struc) generic map(4)
         PORT MAP (a, b, '0', '0',"10", r_add, Z_add, ov_add);
ALUsub: entity work.ALU(struc) generic map(4)
         PORT MAP (a,b, '0', '1',"10", r_sub, Z_sub, ov_sub);
ALUless: entity work.ALU(struc) generic map(4)
         PORT MAP (a,b,'0', '1',"11", r_less, Z_less, ov_less);
END ARCHITECTURE TEST;





